C16=0
	org $1001-2
	dw  $1001
	
	dw nextln,0				; second word is line number
	db $9E,"4109",0
nextln	db 0,0
	
	include "!playerv.asm"

bmp_src_1	= $80
bmp_src_2	= $82
mask_src_1	= $84
mask_src_2	= $86
bmp_dst_1	= $88
bmp_dst_2	= $8A

scrollx		= $A0
char_src1	= $A2
char_dst1	= $A4
char_src2	= $A6
char_dst2	= $A8
char_src3	= $AA
char_dst3	= $AC

text_ptr	= $B0
and_slice	= $B2
remaining_width	= $B3
step_counter	= $B4

blink1		= $B8
blink2		= $B9

tmp_lum		= $BA
tmp_color	= $BB

rc4_end_index	= $BC

SCROLL_SPEED	= 2
	
fli1		= $C000    
fli2		= $C800
fli3		= $D000
fli4		= $D800

font		= $0800
SCREEN		= $0800
colormap	= $1800
pic		= $2000
SCROLL_POS	= fli1+$0400+19*40
	
start
	sei
	sta $ff3f
	;
	ldx #$FF				; sync value for PAL
	;
	lda $FF07
	and #$40
	beq pal1
	;
	lda #$C8
	sta ntsc2+1
	lda #$A2
	sta ntsc3+1
	lda #$F9
	sta ntsc4+1
	;
	; -
	;
	ldx #$F8				; sync value for NTSC
pal1	cpx $FF1D
	bne *-3
	;
	lda #$00
	sta $FF19
	sta $FF15
	sta blink1
	ldx #$0B
	stx $FF06
	ldx #210
	stx blink2
	;
	jsr PLAYER_INIT
	; 
	lda $FF12
	and #$03				; keep lowest 2 bits (sound)	
	ora #pic >> 10				; bitmap address
	sta $FF12
	;
	lda #font >> 8
	sta $FF13
	;
	lda #colormap >> 8			; color map address
	sta $FF14
	;
	ldx #$00
	txa
il5	sta $0800,x
	sta $0900,x
	sta $0E00,x
	inx
	bne il5
	;
	; ---
	;
	ldx #$FF				; memory detection
	lda $4100
	eor #$AA
	sta $0100
	cmp $4100
	beq is_c16
	;
	jsr init_64k				; 64K only
	;
is_c16	lda #$2A
	cmp $FF1D
	bne *-3
	lda #$1B
	sta $FF06
	;
	; ---
	;
	jsr set_irq1
	;
	cli
	;
	jmp *
        
irq1	pha
	txa
	pha
	tya
	pha
	;
	asl $02
	asl $02
	asl $02
	asl $02
	asl $02
	;
	ldy #$B4
	ldx #$0F
l01	lda raster_colors_1+$12,x
	cpy $FF1E
	bcs *-3
	sta $FF19
	sta $FF15
	dex
	bpl l01
	;
	ldy #$A8
	ldx #$11
l02	lda raster_colors_1,x
	cpy $FF1E
	bcs *-3
	sta $FF19
	sta $FF15
	dex
	bne l02
	;
	lda #$3B				; turn graphics mode on
	sta $FF06
	;
middle_background_color
	lda #$00
	sta $FF19
	sta $FF15
	;
	jsr PLAYER
	;
	jsr animate_blink
	;
	if C16=0
	;dec $FF19
scroll_call
	bit scroll
	;inc $FF19
	endif
	;
irq2_enabled
	lda #$00
	bne set_irq2
	;
	jmp go_to_irq3
	;
set_irq2
	lda #$00				; will be set to "irq2"
	ldx #$00
	sta $FFFE
	stx $FFFF
	lda #$A2
	sta $FF0A
	lda #$99
	sta $FF0B
	;
	asl $FF09
	;
	pla
	tay
	pla
	tax
	pla
	rti

go_to_irq3
	lda #irq3 & 255
	sta $FFFE
	lda #irq3 >> 8
	sta $FFFF
	lda #$A2
	sta $FF0A
	lda #$BA
	sta $FF0B
	;
	asl $FF09
	;
	pla
	tay
	pla
	tax
	pla
	rti
	
irq3	pha
	txa
	pha
	tya
	pha
	;
colormap_2
	lda #colormap >> 8
	sta $FF14
	;
	asl $02
	asl $02
	nop
	;
	ldy #$A8
	ldx #$10
	;
	lda #$1B
	sta $FF06
	;
l20	lda raster_colors_2+$11,x
	cpy $FF1E
	bcs *-3
	sta $FF19
	sta $FF15
	dex
	bpl l20
	;
	ldy #$B4
	ldx #$10
l21	lda raster_colors_2,x
	cpy $FF1E
	bcs *-3
	sta $FF19
	sta $FF15
	dex
	bpl l21
	;
	jsr PLAYER
	;
ntsc2	lda #$88
	sta $FF07
	;
	; ---
	;
	if C16=0
	;dec $FF19
process_timeline_call
	bit process_timeline
	;inc $FF19
	;
	;dec $FF19
roll_call
	bit roll_colors_1
	;inc $FF19
	endif
	;
	jsr set_irq1
	;
	pla
	tay
	pla
	tax
	pla
	rti

set_irq1
	lda #irq1 & 255
	sta $FFFE
	lda #irq1 >> 8
	sta $FFFF
ntsc3	lda #$A3
	sta $FF0A
ntsc4	lda #$2A
	sta $FF0B
	;
	asl $FF09
	rts
	
	;
	; **************************************
	;

animate_blink
	lda blink1
	clc
	adc #$01
	cmp #211
	bne *+4
	lda #0
	sta blink1
	lsr a
	cmp #$08
	bcs no_blink1
	;
	asl a
	asl a
	asl a
	asl a
	tax
	ldy #$00
bl1	lda blink,x
	sta pic + 12 * 320 + 13 * 8,y
	lda blink+8,x
	sta pic + 12 * 320 + 16 * 8,y
	inx
	iny
	cpy #8
	bne bl1
	;
no_blink1
	;
	lda blink2
	clc
	adc #$01
	cmp #227
	bne *+4
	lda #0
	sta blink2
	lsr a
	cmp #$08
	bcs no_blink2
	;
	asl a
	asl a
	asl a
	asl a
	tax
	ldy #$00
bl2	lda blink,x
	sta pic + 12 * 320 + 23 * 8,y
	lda blink+8,x
	sta pic + 12 * 320 + 26 * 8,y
	inx
	iny
	cpy #8
	bne bl2
	;
no_blink2
	rts
	
	include "blink.asm"

music_beg
	include "!player.asm"
	include "!player_data.asm"
	include "music.asm"
music_end
 
	org $1800
	include "pic.asm"

raster_colors_1
	db $71
	db $02,$0B,$12,$1B,$22,$2B,$32,$3B
	db $42,$4B,$52,$5B,$62,$6B,$72,$71
	db $71,$7C,$65,$6C,$55,$5C,$45,$4C
	db $35,$3C,$25,$2C,$15,$1C,$05,$0C
	db 0
raster_colors_2
	db $00
	db $0C,$05,$1C,$15,$2C,$25,$3C,$35
	db $4C,$45,$5C,$55,$6C,$65,$7C,$71
	db $71,$72,$6B,$62,$5B,$52,$4B,$42
	db $3B,$32,$2B,$22,$1B,$12,$0B,$02
	db $00
	
	;
	; **************************************
	;

	if C16=0
	align 256
init_64k
	lda $FF07
	and #$40
	beq init_64k_2
	;
	lda #$C0				; 64K only NTSC changes
	sta ntsc1+1
	lda #$CA				; DEX opcode
	sta ntsc5
	sta ntsc5+1
	sta ntsc7
	sta ntsc7+1
	sta ntsc9
	sta ntscA
	lda #$01
	sta ntsc6+1
	sta ntsc8+1
	sta ntscB+1
	;
	ldx #roll_colors_1_ntsc_src_end - roll_colors_1_ntsc_src
ntsc_l1	lda roll_colors_1_ntsc_src,x
	sta roll_colors_1_ntsc_dst,x
	dex
	bpl ntsc_l1
	;
	lda #(rc1_end_index - $22) & 255
	sta rc1b+1
	sta rc1c+1
	lda #(rc1_end_index - $22) >> 8
	sta rc1b+2
	sta rc1c+2
	;
init_64k_2
	ldx #39
il1	lda #$00
	sta SCREEN+0*40,x
	sta SCREEN+1*40,x
	sta SCREEN+$0400+0*40,x
	sta SCREEN+$0400+1*40,x
	;
	lda #$46
	sta fli1 +19*40,x
	sta fli2 +19*40,x
	sta fli3 +19*40,x
	sta fli4 +19*40,x
	;
	sta fli1 +20*40,x
	sta fli2 +20*40,x
	sta fli3 +20*40,x
	sta fli4 +20*40,x
	;
	sta fli1 +21*40,x
	sta fli2 +21*40,x
	sta fli3 +21*40,x
	sta fli4 +21*40,x
	;
	txa
	clc
	adc #$40
	sta SCROLL_POS+0*40,x
	clc
	adc #40
	sta SCROLL_POS+1*40,x
	clc
	adc #40
	sta SCROLL_POS+2*40,x
	;
	dex
	bpl il1
	;
	lda #$20				; JSR $0000 opcode
	sta process_timeline_call
	jsr init_timeline
	;
	; --
	lda #$00
	sta scrollx
	lda #text_data & 255
	sta text_ptr
	lda #text_data >> 8
	sta text_ptr+1
	lda #$00
	sta remaining_width
	lda #35
	sta rc4_end_index
	;
	ldx #$07
	ldy #$00
il2	lda corner_gfx,x			; add the rounded corners to the picture
	sta pic + 3 * 320,x
	sta pic + 5 * 320 + 6 * 8,x
	sta pic + 21 * 320,y			; y counts up to mirror corner
	sta pic + 19 * 320 + 6 * 8,y
	;
	lda corner_gfx+8,x
	sta pic + 3 * 320 + 39 * 8,x
	sta pic + 5 * 320 + 33 * 8,x
	sta pic + 21 * 320 + 39 * 8,y
	sta pic + 19 * 320 + 33 * 8,y
	;
	iny
	dex
	bpl il2
	;
	ldx #208				; width
	lda #$00
il3	sta pic + 19 * 320 + 7*8-1,x		; erase the text (only needed for the C16 version)
	sta pic + 20 * 320 + 7*8-1,x		; 3 lines
	sta pic + 21 * 320 + 7*8-1,x
	dex
	bne il3
	;
	; ---
	;
	lda #colormap_64k >> 8
	sta $FF14
	sta colormap_1+1
	sta colormap_2+1
	;
	; ---
	;
	ldx #$00
	lda #$00
il4	sta $0800,x
	sta $0900,x
	sta $0A00,x
	sta $0B00,x
	sta $0C00,x
	sta $0D00,x
	sta $0E00,x
	sta $0F00,x
	inx
	bne il4
	;
	ldx #33
	lda #0
il6	sta raster_colors_1,x
	sta raster_colors_2,x
	dex
	bpl il6
	;
	; ---
	;
	lda #irq2 & 255
	sta set_irq2 + 1
	lda #irq2 >> 8
	sta set_irq2 + 3
	;
	rts
	
	;
	; **************************************
	;

fli	macro ff14_value, ff06_value
	asl $02 			; 15
	asl $02
	asl $02
	;
	lda #ff14_value
	sta $FF14			; Video Matrix
	lda #ff06_value
	sta $FF06			; Vert Scroll to cause badline
	;  
	nop				; 17
	nop
	nop
	nop
	nop
	asl $02
	endm
	
irq2	pha
	txa
	pha
	tya
	pha
	;
	lda $FF1E
	cmp #$4E
	beq ah16			; ahead by 16
	cmp #$4A
	beq ah12			; ahead by 12
	cmp #$46			; one cycle = HC increases by 4
	beq ah8				; ahead by 8
	cmp #$42
	beq ah4				; ahead by 4
	cmp #$3E
	beq ah0				; lowest value
	;
ah16	bit $24
ah12	bit $24
ah8	bit $24
ah4	bit $24
ah0	;
	lda scrollx
ntsc1	ora #$80
	sta $FF07
	;
	asl $02
	asl $02
	;
	; lda for ff14 is at $AA/$53
	fli fli1 >> 8, $1D
	fli fli2 >> 8, $1F
	fli fli3 >> 8, $19
	fli fli4 >> 8, $1B
	;
	fli fli1 >> 8, $1D
	fli fli2 >> 8, $1F
	fli fli3 >> 8, $19
	fli fli4 >> 8, $1B
	;
	fli fli1 >> 8, $1D
	fli fli2 >> 8, $1F
	fli fli3 >> 8, $19
	fli fli4 >> 8, $1B
	;
	fli fli1 >> 8, $1D
	fli fli2 >> 8, $1F
	fli fli3 >> 8, $19
	fli fli4 >> 8, $1B
	;
colormap_1
	lda #colormap >> 8
	sta $FF14
	lda #$1B
	sta $FF06
	;
	jmp go_to_irq3
	
	;
	; **************************************
	;
	
scroll	lda scrollx
	sec
	sbc #SCROLL_SPEED
	sta scrollx
	;
	bpl scr1
	;
	and #$07
	sta scrollx
	;
	lda SCROLL_POS+0*40
	pha
	lda SCROLL_POS+1*40
	pha
	lda SCROLL_POS+2*40
	pha
	;
	ldx #$00
scr2	lda SCROLL_POS+0*40+1,x			; move chars on screen
	sta SCROLL_POS+0*40+0,x
	sta SCROLL_POS+0*40+0 + $0800,x
	sta SCROLL_POS+0*40+0 + $1000,x
	sta SCROLL_POS+0*40+0 + $1800,x
	lda SCROLL_POS+1*40+1,x
	sta SCROLL_POS+1*40+0,x
	sta SCROLL_POS+1*40+0 + $0800,x
	sta SCROLL_POS+1*40+0 + $1000,x
	sta SCROLL_POS+1*40+0 + $1800,x
	lda SCROLL_POS+2*40+1,x
	sta SCROLL_POS+2*40+0,x
	sta SCROLL_POS+2*40+0 + $0800,x
	sta SCROLL_POS+2*40+0 + $1000,x
	sta SCROLL_POS+2*40+0 + $1800,x
	inx
	cpx #39
	bne scr2
	;
	pla
	sta SCROLL_POS+2*40+39
	pla
	sta SCROLL_POS+1*40+39
	pla
	sta SCROLL_POS+0*40+39
	;
scr1	; ---
	;
	lda SCROLL_POS+0*40+39			; calc dest pointers
	sta char_dst1
	lda #$00
	sta char_dst1+1
	;
	asl char_dst1 
	rol char_dst1+1
	asl char_dst1 
	rol char_dst1+1
	asl char_dst1 
	rol char_dst1+1
	;
	lda char_dst1+1
	ora #font >> 8
	sta char_dst1+1
	;
	lda char_dst1
	clc
	adc #$40
	sta char_dst2
	lda char_dst1+1
	adc #$01
	sta char_dst2+1
	;
	lda char_dst2
	clc
	adc #$40
	sta char_dst3
	lda char_dst2+1
	adc #$01
	sta char_dst3+1
	;
	; ---
	;
	lda scrollx				; erase full char on every new char
	cmp #$06
	bne scr5
	;
	ldy #$07
	lda #$00
scr6	sta (char_dst1),y
	sta (char_dst2),y
	sta (char_dst3),y
	dey
	bpl scr6
	;
scr5	lda remaining_width
	bne scr7
	;
	; --- new char
	;
	ldy #$00
txt2	lda (text_ptr),y
	bpl txt1
	;
	lda #text_data & 255
	sta text_ptr
	lda #text_data >> 8
	sta text_ptr+1
	bne txt2
	;
txt1	tax
	;
	lda text_ptr
	clc
	adc #$01
	sta text_ptr
	bcc *+4
	inc text_ptr+1
	;
	lda letter_widths,x
	sta remaining_width
	lda scrollx
	clc
	adc #$02
	sta step_counter
	;
	lda letter_ptr_lo,x
	sta char_src1
	lda letter_ptr_hi,x
	ldy scrollx
	clc
	adc charset_hi,y
	sta char_src1+1
	;
	lda char_src1
	clc
	adc #$10
	sta char_src2
	lda char_src1+1
	adc #$00
	sta char_src2+1
	;
	lda char_src2
	clc
	adc #$10
	sta char_src3
	lda char_src2+1
	adc #$00
	sta char_src3+1
	;
	; ---
	;
scr7	lda remaining_width
	cmp #$02
	beq src9
	;
	ldx scrollx
	lda and_slices,x
	sta and_slice
	;
	ldy #$07
cp0	lda (char_src1),y
	and and_slice
	ora (char_dst1),y 
	sta (char_dst1),y
	;
	lda (char_src2),y
	and and_slice
	ora (char_dst2),y 
	sta (char_dst2),y
	;
	lda (char_src3),y
	and and_slice
	ora (char_dst3),y 
	sta (char_dst3),y
	;
	dey
	bpl cp0
	;
	; --
	;
src9	lda remaining_width
	sec
	sbc #$02
	sta remaining_width 
	;
	lda step_counter
	sec
	sbc #$02
	sta step_counter
	bne src10
	;
	lda char_src1
	clc
	adc #$08
	sta char_src1
	bcc *+4
	inc char_src1+1
	;
	lda char_src2
	clc
	adc #$08
	sta char_src2
	bcc *+4
	inc char_src2+1
	;
	lda char_src3
	clc
	adc #$08
	sta char_src3
	bcc *+4
	inc char_src3+1
	;
src10	rts

	;
	; **************************************
	;

rc5	macro offset
	lda fli1 +19*40+offset+1
	sta fli1 +19*40+offset
	sta fli2 +19*40+offset
	sta fli3 +19*40+offset
	sta fli4 +20*40+offset
	sta fli1 +20*40+offset
	sta fli2 +20*40+offset
	sta fli3 +20*40+offset
	sta fli4 +21*40+offset
	sta fli1 +21*40+offset
	sta fli2 +21*40+offset
	sta fli3 +21*40+offset
	endm

roll_colors_5
	ldx #$00
	inx
	txa
	and #$03
	sta roll_colors_5+1
	beq rc51
	rts
	;
rc51	;
	rc5 0
	rc5 1
	rc5 2
	rc5 3
	rc5 4
	rc5 5
	rc5 6
	rc5 7
	rc5 8
	rc5 9
	rc5 10
	rc5 11
	rc5 12
	rc5 13
	rc5 14
	rc5 15
	rc5 16
	rc5 17
	rc5 18
	rc5 19
	rc5 20
	rc5 21
	rc5 22
	rc5 23
	rc5 24
	rc5 25
	rc5 26
	rc5 27
	rc5 28
	rc5 29
	rc5 30
	rc5 31
	rc5 32
	rc5 33
	rc5 34
	rc5 35
	rc5 36
	rc5 37
	rc5 38
	rts

set_scroll_color_1
	lda #$32
	db $2C
set_scroll_color_2
	lda #$2C
	db $2C
set_scroll_color_3
	lda #$46
	;
	sta fli1 +19*40+39
	sta fli2 +19*40+39
	sta fli3 +19*40+39
	sta fli4 +20*40+39
	sta fli1 +20*40+39
	sta fli2 +20*40+39
	sta fli3 +20*40+39
	sta fli4 +21*40+39
	sta fli1 +21*40+39
	sta fli2 +21*40+39
	sta fli3 +21*40+39
	;
	rts

roll_colors_4
	ldx #39
rc4	txa
	clc
rc4a	adc #$00
	and #$0F
rc4_start_index1
	cpx #40
	bcc rc4_01
	lda #$46
	bne rc4_02
rc4_01	tay
	lda final_colors+0,y
	ora rainbow1,x
rc4_02	sta fli1 +19*40,x
	sta fli3 +19*40,x
	sta fli1 +20*40,x
	sta fli3 +20*40,x
	sta fli1 +21*40,x
	sta fli3 +21*40,x
	;
rc4_start_index2
	cpx #40
	bcc rc4_03
	lda #$46
	bne rc4_04
rc4_03	lda final_colors+0,y
	ora rainbow2,x
rc4_04	sta fli2 +19*40,x
	sta fli4 +20*40,x
	sta fli2 +20*40,x
	sta fli4 +21*40,x
	sta fli2 +21*40,x
	;
ntsc9	nop
	cpx rc4_end_index
	beq rc4d
ntscA	nop
	cpx rc4_end_index
	beq rc4d
	dex
	cpx rc4_end_index
	beq rc4d
	jmp rc4
	;
rc4d	ldx rc4a+1
	dex
	txa
	and #$0F
	sta rc4a+1
	;
	and #$03
	bne rc4c
	;
	lda rc4_end_index
	bmi rc4b
	sec
	sbc #$01
rc4b	sta rc4_end_index
	;
	lda rc4_start_index1+1
	sec
rc4_sub	sbc #$00
	sta rc4_start_index1+1
	sta rc4_start_index2+1
	;
rc4c	lda roll_colors_4+1
	sec
ntscB	sbc #$00
	cmp #36
	bne *+4
	lda #39
	sta roll_colors_4+1
	rts

stop_roll_colors_4
	lda #$01
	sta rc4_sub+1
	rts

roll_colors_3
	ldx #39
rc3	txa
	clc
rc3a	adc #$00
	and #$0F
	tay
	lda final_colors+0,y
rc3_color
	ora #$05
	sta fli1 +19*40,x
	lda final_colors+1,y
	ora #$05
	sta fli2 +19*40,x
	lda final_colors+2,y
	ora #$05
	sta fli3 +19*40,x
	lda final_colors+3,y
	ora #$05
	sta fli4 +20*40,x
	lda final_colors+4,y
	ora #$05
	sta fli1 +20*40,x
	lda final_colors+5,y
	ora #$05
	sta fli2 +20*40,x
	lda final_colors+6,y
	ora #$05
	sta fli3 +20*40,x
	lda final_colors+7,y
	ora #$05
	sta fli4 +21*40,x
	lda final_colors+8,y
	ora #$05
	sta fli1 +21*40,x
	lda final_colors+9,y
	ora #$05
	sta fli2 +21*40,x
	lda final_colors+10,y
	ora #$05
	sta fli3 +21*40,x
	;
ntsc7	nop
	nop
	dex
	bpl rc3
	;
	ldx rc3a+1
	dex
	txa
	and #$0F
	sta rc3a+1
	;
	lda roll_colors_3+1
	sec
ntsc8	sbc #$00
	cmp #36
	bne *+4
	lda #39
	sta roll_colors_3+1
	;
	rts
	
switch_color_3
	inc switch_color_3_delay+1
switch_color_3_delay
	lda #$00
	and #$03
	bne swc3x
	;
switch_color_3_index
	ldx #1
switch_color_3_color_index
	ldy #$16
	lda rainbow1,y
	sta rc3_color,x
	;
	txa
	clc
	adc #8
	;
	cmp #89
	bne swc31
	;
	inc switch_color_3_color_index+1
	inc switch_color_3_color_index+1
	;
	lda #$01        
swc31	sta switch_color_3_index+1
swc3x	rts

roll_colors_2
	ldx #39
rc2	lda sine,x
	tay
	lda final_colors+0,y
	ora rainbow1,x
	sta fli1 +19*40,x
	lda final_colors+1,y
	ora rainbow2,x
	sta fli2 +19*40,x
	lda final_colors+2,y
	ora rainbow1,x
	sta fli3 +19*40,x
	lda final_colors+3,y
	ora rainbow2,x
	sta fli4 +20*40,x
	lda final_colors+4,y
	ora rainbow1,x
	sta fli1 +20*40,x
	lda final_colors+5,y
	ora rainbow2,x
	sta fli2 +20*40,x
	lda final_colors+6,y
	ora rainbow1,x
	sta fli3 +20*40,x
	lda final_colors+7,y
	ora rainbow2,x
	sta fli4 +21*40,x
	lda final_colors+8,y
	ora rainbow1,x
	sta fli1 +21*40,x
	lda final_colors+9,y
	ora rainbow2,x
	sta fli2 +21*40,x
	lda final_colors+10,y
	ora rainbow1,x
	sta fli3 +21*40,x
	;
ntsc5	nop
	nop
	dex
	bpl rc2
	;
	ldx rc2+1
	inx
	txa
	and #$7F
	sta rc2+1
	;
	lda roll_colors_2+1
	sec
ntsc6	sbc #$00
	cmp #36
	bne *+4
	lda #39
	sta roll_colors_2+1
	;
	rts

roll_colors_1_ntsc_src
	sta fli3 +19*40,x
	sbc $FF03
	and #$60
	ora #$0D
	sta fli4 +20*40,x
	sta fli1 +20*40,x
	adc $FF01
	and #$60
	ora #$06
	sta fli2 +20*40,x
	sta fli3 +20*40,x
	eor $FF03
	and #$60
	ora #$0E
	sta fli4 +21*40,x
	sta fli1 +21*40,x
	sbc $FF01
	and #$60
	ora #$0E
	sta fli2 +21*40,x
	sta fli3 +21*40,x
	dex
	cpx #38
	db $D0,$B0	; BNE
	db $F0,$21	; BEQ
roll_colors_1_ntsc_src_end

roll_colors_1
rc1_start_index
	ldx #39
rc1	lda $FF00
	and #$60
	ora #$03
	sta fli1 +19*40,x
	eor $FF01
	and #$60
	ora #$0D
	sta fli2 +19*40,x
	;
roll_colors_1_ntsc_dst
	adc $FF02
	and #$60
	ora #$0D
	sta fli3 +19*40,x
	sbc $FF03
	and #$60
	ora #$0D
	sta fli4 +20*40,x
	eor $FF00
	and #$60
	ora #$06
	sta fli1 +20*40,x
	adc $FF01
	and #$60
	ora #$06
	sta fli2 +20*40,x
	sbc $FF02
	and #$60
	ora #$06
	sta fli3 +20*40,x
	eor $FF03
	and #$60
	ora #$0E
	sta fli4 +21*40,x
	adc $FF00
	and #$60
	ora #$0E
	sta fli1 +21*40,x
	sbc $FF01
	and #$60
	ora #$0E
	sta fli2 +21*40,x
	eor $FF02
	and #$60
	ora #$0E
	sta fli3 +21*40,x
	dex
rc1_end_index
	cpx #38
	bne rc1
	;
	inc rc1a+1
rc1a	lda #$00
	and #$03
	bne rc1x
	;
rc1b	lda rc1_end_index+1
	bmi rc1c
	sec
	sbc #$01
rc1c	sta rc1_end_index+1
	;
	lda rc1_start_index+1
	beq rc1d
	sec
rc1_sub	sbc #$00
rc1d	sta rc1_start_index+1 
	;
rc1x	rts

stop_roll_colors_1
	lda #$01
	sta rc1_sub+1
	rts

reveal_raster_sine
	db $01,$02,$03,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0E,$0F,$0F
	db $0F,$0F,$0F,$0F,$0F,$0F,$0E,$0E,$0E,$0E,$0D,$0D,$0D,$0D,$0C,$0C
	db $0C,$0C,$0C,$0C,$0D,$0D,$0E,$0E,$0F,$10,$11,$12,$13,$15,$16,$18
	db $19,$1A,$1B,$1D,$1E,$20,$21
reveal_raster_sine_end

reveal_raster
	ldx #33
	lda #0
rev1	sta raster_colors_1,x
	sta raster_colors_2,x
	dex
	bpl rev1
	;
reveal_raster_index
	ldx #$00
	lda reveal_raster_sine,x
	sta rev2+1
	;
	ldx #0
	ldy #33
rev3	lda raster_colors_1_orig,x
	sta raster_colors_1,x
	lda raster_colors_2_orig,y
	sta raster_colors_2,y
	dey
	inx
rev2	cpx #$00
	bne rev3
	;
	inc reveal_raster_index+1
	rts

fade_in_sides
	inc delay_timer_1+1
delay_timer_1
	lda #$00
	and #$01
	beq cont_1
	rts
cont_1	;
	lda #$22
	sta tmp_color
	;
	lda middle_background_color+1
	beq fis0
	cmp #$72
	bne fis1
	lda #$11
	sta tmp_color
	lda #$71
	bne fis2
fis0	lda #$02
	bne fis2
fis1	clc
	adc #$10
fis2	sta middle_background_color+1
	sta raster_colors_2+33
	;
	ldx #39
fis3	sta colormap_64k + 22*40,x
	sta colormap_64k + $0400 + 22*40,x
	dex
	bpl fis3
	;
	and #$F0
	sta tmp_lum
	lsr a
	lsr a
	lsr a
	lsr a
	ora tmp_lum
	sta tmp_lum
	;
	ldx #39
fis4	lda tmp_lum
	sta colormap_64k + 2*40,x
	lda tmp_color
	sta colormap_64k + $0400 + 2*40,x
	dex
	bpl fis4
	;
	; --- corners
	;
	lda tmp_lum
	and #$0F
	sta colormap_64k + 3*40
	sta colormap_64k + 3*40 + 39
	sta colormap_64k + 21*40
	sta colormap_64k + 21*40 + 39
	lda tmp_color
	and #$F0
	sta colormap_64k + $0400 + 3*40
	sta colormap_64k + $0400 + 3*40 + 39
	sta colormap_64k + $0400 + 21*40
	sta colormap_64k + $0400 + 21*40 + 39
	;
	rts

fade_in_mid1_02
	lda #$11
	db $2C
fade_in_mid1_00
	lda #$44
	;
	ldx #39
fim1	sta colormap_64k + $0400 + 3*40,x
	sta colormap_64k + $0400 + 4*40,x
	sta colormap_64k + $0400 + 20*40,x
	sta colormap_64k + $0400 + 21*40,x
	dex
	bpl fim1
	;
	ldx #5
fim2	sta colormap_64k + $0400 + 5*40,x
	sta colormap_64k + $0400 + 6*40,x
	sta colormap_64k + $0400 + 7*40,x
	sta colormap_64k + $0400 + 8*40,x
	sta colormap_64k + $0400 + 9*40,x
	sta colormap_64k + $0400 + 10*40,x
	sta colormap_64k + $0400 + 11*40,x
	sta colormap_64k + $0400 + 12*40,x
	sta colormap_64k + $0400 + 13*40,x
	sta colormap_64k + $0400 + 14*40,x
	sta colormap_64k + $0400 + 15*40,x
	sta colormap_64k + $0400 + 16*40,x
	sta colormap_64k + $0400 + 17*40,x
	sta colormap_64k + $0400 + 18*40,x
	sta colormap_64k + $0400 + 19*40,x
	;
	sta colormap_64k + $0400 + 5*40 + 34,x
	sta colormap_64k + $0400 + 6*40 + 34,x
	sta colormap_64k + $0400 + 7*40 + 34,x
	sta colormap_64k + $0400 + 8*40 + 34,x
	sta colormap_64k + $0400 + 9*40 + 34,x
	sta colormap_64k + $0400 + 10*40 + 34,x
	sta colormap_64k + $0400 + 11*40 + 34,x
	sta colormap_64k + $0400 + 12*40 + 34,x
	sta colormap_64k + $0400 + 13*40 + 34,x
	sta colormap_64k + $0400 + 14*40 + 34,x
	sta colormap_64k + $0400 + 15*40 + 34,x
	sta colormap_64k + $0400 + 16*40 + 34,x
	sta colormap_64k + $0400 + 17*40 + 34,x
	sta colormap_64k + $0400 + 18*40 + 34,x
	sta colormap_64k + $0400 + 19*40 + 34,x
	dex
	bpl fim2
	;
	; --- corners
	;
	sta tmp_color
	and #$0F
	ora #$10
	sta colormap_64k + $0400 + 3*40
	sta colormap_64k + $0400 + 3*40 + 39
	sta colormap_64k + $0400 + 21*40
	sta colormap_64k + $0400 + 21*40 + 39
	;
	lda tmp_color
	and #$F0
	sta colormap_64k + $0400 + 5*40 + 6
	sta colormap_64k + $0400 + 5*40 + 33
	sta colormap_64k + $0400 + 19*40 + 6
	sta colormap_64k + $0400 + 19*40 + 33
	;
	rts

fade_in_mid1_01
	lda #$11
	ldx #39
fim3	sta colormap_64k + 3*40,x
	sta colormap_64k + 4*40,x
	sta colormap_64k + 20*40,x
	sta colormap_64k + 21*40,x
	dex
	bpl fim3
	;
	ldx #5
fim4	sta colormap_64k + 5*40,x
	sta colormap_64k + 6*40,x
	sta colormap_64k + 7*40,x
	sta colormap_64k + 8*40,x
	sta colormap_64k + 9*40,x
	sta colormap_64k + 10*40,x
	sta colormap_64k + 11*40,x
	sta colormap_64k + 12*40,x
	sta colormap_64k + 13*40,x
	sta colormap_64k + 14*40,x
	sta colormap_64k + 15*40,x
	sta colormap_64k + 16*40,x
	sta colormap_64k + 17*40,x
	sta colormap_64k + 18*40,x
	sta colormap_64k + 19*40,x
	;
	sta colormap_64k + 5*40 + 34,x
	sta colormap_64k + 6*40 + 34,x
	sta colormap_64k + 7*40 + 34,x
	sta colormap_64k + 8*40 + 34,x
	sta colormap_64k + 9*40 + 34,x
	sta colormap_64k + 10*40 + 34,x
	sta colormap_64k + 11*40 + 34,x
	sta colormap_64k + 12*40 + 34,x
	sta colormap_64k + 13*40 + 34,x
	sta colormap_64k + 14*40 + 34,x
	sta colormap_64k + 15*40 + 34,x
	sta colormap_64k + 16*40 + 34,x
	sta colormap_64k + 17*40 + 34,x
	sta colormap_64k + 18*40 + 34,x
	sta colormap_64k + 19*40 + 34,x
	;
	dex
	bpl fim4
	;
	; --- corners
	;
	sta tmp_lum
	and #$F0
	ora #$07
	sta colormap_64k + 3*40
	sta colormap_64k + 3*40 + 39
	sta colormap_64k + 21*40
	sta colormap_64k + 21*40 + 39
	;
	; --- corners
	;
	lda tmp_lum
	and #$0F
	sta colormap_64k + 5*40 + 6
	sta colormap_64k + 5*40 + 33
	sta colormap_64k + 19*40 + 6
	sta colormap_64k + 19*40 + 33
	;
	lda tmp_lum
	clc
	adc #$11
	sta fade_in_mid1_01+1
	;
	rts

fade_in_mid2_02
	lda #$11
	db $2C
fade_in_mid2_00
	lda #$66
	;
	ldx #27
fim21	sta colormap_64k + $0400 + 5*40+ 6,x
	sta colormap_64k + $0400 + 6*40+ 6,x
	sta colormap_64k + $0400 + 7*40+ 6,x
	sta colormap_64k + $0400 + 8*40+ 6,x
	sta colormap_64k + $0400 + 9*40+ 6,x
	sta colormap_64k + $0400 + 10*40+ 6,x
	sta colormap_64k + $0400 + 11*40+ 6,x
	sta colormap_64k + $0400 + 12*40+ 6,x
	sta colormap_64k + $0400 + 13*40+ 6,x
	sta colormap_64k + $0400 + 14*40+ 6,x
	sta colormap_64k + $0400 + 15*40+ 6,x
	sta colormap_64k + $0400 + 16*40+ 6,x
	sta colormap_64k + $0400 + 17*40+ 6,x
	sta colormap_64k + $0400 + 18*40+ 6,x
	sta colormap_64k + $0400 + 19*40+ 6,x
	dex
	bpl fim21
	;
	; --- corners
	;
	and #$0F
	ora #$10
	sta colormap_64k + $0400 + 5*40 + 6
	sta colormap_64k + $0400 + 5*40 + 33
	sta colormap_64k + $0400 + 19*40 + 6
	sta colormap_64k + $0400 + 19*40 + 33
	;
	rts

fade_in_mid2_01
	lda #$11
	;
	ldx #27
fim22	sta colormap_64k + 5*40+ 6,x
	sta colormap_64k + 6*40+ 6,x
	sta colormap_64k + 7*40+ 6,x
	sta colormap_64k + 8*40+ 6,x
	sta colormap_64k + 9*40+ 6,x
	sta colormap_64k + 10*40+ 6,x
	sta colormap_64k + 11*40+ 6,x
	sta colormap_64k + 12*40+ 6,x
	sta colormap_64k + 13*40+ 6,x
	sta colormap_64k + 14*40+ 6,x
	sta colormap_64k + 15*40+ 6,x
	sta colormap_64k + 16*40+ 6,x
	sta colormap_64k + 17*40+ 6,x
	sta colormap_64k + 18*40+ 6,x
	sta colormap_64k + 19*40+ 6,x
	dex
	bpl fim22
	;
	; --- corners
	;
	tax
	and #$F0
	ora #$07
	sta colormap_64k + 5*40 + 6
	sta colormap_64k + 5*40 + 33
	sta colormap_64k + 19*40 + 6
	sta colormap_64k + 19*40 + 33
	;
	txa
	clc
	adc #$11
	sta fade_in_mid2_01+1
	;
	rts

reveal_left
	ldx #7
rl1	lda colormap             + 2*40+11,x
	sta colormap_64k         + 2*40+11,x
	lda colormap     + $0400 + 2*40+11,x
	sta colormap_64k + $0400 + 2*40+11,x
	dex
	bpl rl1
	;
	lda rl1+1
	clc
	adc #40
	sta rl1+1
	bcc *+5
	inc rl1+2
	;
	lda rl1+4
	clc
	adc #40
	sta rl1+4
	bcc *+5
	inc rl1+5
	;
	lda rl1+7
	clc
	adc #40
	sta rl1+7
	bcc *+5
	inc rl1+8
	;
	lda rl1+10
	clc
	adc #40
	sta rl1+10
	bcc *+5
	inc rl1+11
	;
	rts

reveal_right
	ldx #7
rr1	lda colormap             + 2*40+21,x
	sta colormap_64k         + 2*40+21,x
	lda colormap     + $0400 + 2*40+21,x
	sta colormap_64k + $0400 + 2*40+21,x
	dex
	bpl rr1
	;
	lda rr1+1
	clc
	adc #40
	sta rr1+1
	bcc *+5
	inc rr1+2
	;
	lda rr1+4
	clc
	adc #40
	sta rr1+4
	bcc *+5
	inc rr1+5
	;
	lda rr1+7
	clc
	adc #40
	sta rr1+7
	bcc *+5
	inc rr1+8
	;
	lda rr1+10
	clc
	adc #40
	sta rr1+10
	bcc *+5
	inc rr1+11
	;
	rts 
	
reveal_bitmap_colors
	ldx #25
rbs1	lda #$74				; $71 + $46
	sta colormap_64k + 19 * 40 + 7,x
	sta colormap_64k + 20 * 40 + 7,x
	sta colormap_64k + 21 * 40 + 7,x
	lda #$61
	sta colormap_64k + $0400 + 19 * 40 + 7,x
	sta colormap_64k + $0400 + 20 * 40 + 7,x
	sta colormap_64k + $0400 + 21 * 40 + 7,x
	dex
	bpl rbs1
	rts

reveal_bitmap_start
	lda #(bitmap + 13 * 8) & 255
	sta bmp_src_1
	lda #(bitmap + 13 * 8) >> 8
	sta bmp_src_1+1
	;
	lda #bitmap_reveal_left & 255
	sta mask_src_1
	lda #bitmap_reveal_left >> 8
	sta mask_src_1+1
	;
	lda #(pic + 19 * 8 + 19 * 320 ) & 255
	sta bmp_dst_1
	lda #(pic + 19 * 8 + 19 * 320 ) >> 8
	sta bmp_dst_1+1
	;
	lda #(bitmap + 14 * 8) & 255
	sta bmp_src_2
	lda #(bitmap + 14 * 8) >> 8
	sta bmp_src_2+1
	;
	lda #bitmap_reveal_right & 255
	sta mask_src_2
	lda #bitmap_reveal_right >> 8
	sta mask_src_2+1
	;
	lda #(pic + 20 * 8 + 19 * 320 ) & 255
	sta bmp_dst_2
	lda #(pic + 20 * 8 + 19 * 320 ) >> 8
	sta bmp_dst_2+1
	;
reveal_bitmap
	ldx #2
rb2	ldy #$0F
rb1	lda (bmp_src_1),y
	and (mask_src_1),y
	sta (bmp_dst_1),y
	lda (bmp_src_2),y
	and (mask_src_2),y
	sta (bmp_dst_2),y
	dey
	bpl rb1
	;
	lda bmp_src_1
	clc
	adc #224
	sta bmp_src_1
	bcc *+4
	inc bmp_src_1+1
	;
	lda mask_src_1
	clc
	adc #$10
	sta mask_src_1
	bcc *+4
	inc mask_src_1+1
	;
	lda bmp_dst_1
	clc
	adc #$40
	sta bmp_dst_1
	lda bmp_dst_1+1
	adc #$01
	sta bmp_dst_1+1
	;
	lda bmp_src_2
	clc
	adc #224
	sta bmp_src_2
	bcc *+4
	inc bmp_src_2+1
	;
	lda mask_src_2
	clc
	adc #$10
	sta mask_src_2
	bcc *+4
	inc mask_src_2+1
	;
	lda bmp_dst_2
	clc
	adc #$40
	sta bmp_dst_2
	lda bmp_dst_2+1
	adc #$01
	sta bmp_dst_2+1
	;
	dex
	bpl rb2
	;
	; ---
	;
	lda bmp_src_1
	sec
	sbc #(224*3) & 255
	sta bmp_src_1
	lda bmp_src_1+1
	sbc #(224*3) >> 8
	sta bmp_src_1+1
	;
	lda bmp_dst_1
	sec
	sbc #(320*3) & 255
	sta bmp_dst_1
	lda bmp_dst_1+1
	sbc #(320*3) >> 8
	sta bmp_dst_1+1
	;
	lda bmp_src_2
	sec
	sbc #(224*3) & 255
	sta bmp_src_2
	lda bmp_src_2+1
	sbc #(224*3) >> 8
	sta bmp_src_2+1
	;
	lda bmp_dst_2
	sec
	sbc #(320*3) & 255
	sta bmp_dst_2
	lda bmp_dst_2+1
	sbc #(320*3) >> 8
	sta bmp_dst_2+1
	;
	; ---
	;
	lda mask_src_1
	cmp #(bitmap_reveal_left + 4 * 3 * $10) & 255
	bne rb3
	;
	lda #bitmap_reveal_left & 255
	sta mask_src_1
	lda #bitmap_reveal_left >> 8
	sta mask_src_1+1
	;
	lda bmp_src_1
	sec
	sbc #8
	sta bmp_src_1
	lda bmp_src_1+1
	sbc #0
	sta bmp_src_1+1 
	;
	lda bmp_dst_1
	sec
	sbc #8
	sta bmp_dst_1
	lda bmp_dst_1+1
	sbc #0
	sta bmp_dst_1+1
	;
	lda #bitmap_reveal_right & 255
	sta mask_src_2
	lda #bitmap_reveal_right >> 8
	sta mask_src_2+1
	;
	lda bmp_src_2
	clc
	adc #8
	sta bmp_src_2
	lda bmp_src_2+1
	adc #0
	sta bmp_src_2+1
	;
	lda bmp_dst_2
	clc
	adc #8
	sta bmp_dst_2
	lda bmp_dst_2+1
	adc #0
	sta bmp_dst_2+1
	;
rb3	rts

erase_bitmap_line_start
	lda #(pic + 7 * 8 + 21 * 320 ) & 255
	sta bmp_dst_1
	lda #(pic + 7 * 8 + 21 * 320 ) >> 8
	sta bmp_dst_1+1
	;
erase_bitmap_line
	ldx #26
eb_index
	ldy #$07
eb1	lda #$00
	sta (bmp_dst_1),y
	;
	tya
	clc
	adc #8
	tay
	dex
	bpl eb1
	;
	tya
	and #$07
	tay
	dey
	bpl eb2
	;
	lda bmp_dst_1
	sec
	sbc #$40
	sta bmp_dst_1
	lda bmp_dst_1+1
	sbc #$01
	sta bmp_dst_1+1
	;
	ldy #$07
eb2	sty eb_index+1 
	;
	rts

start_scroll
	lda #$20
	sta scroll_call
	dec irq2_enabled+1
	rts

roll_lo
	db 0
	db roll_colors_1 & 255
	db roll_colors_2 & 255
	db roll_colors_3 & 255
	db roll_colors_4 & 255
	db roll_colors_5 & 255
roll_hi
	db 0
	db roll_colors_1 >> 8
	db roll_colors_2 >> 8
	db roll_colors_3 >> 8
	db roll_colors_4 >> 8
	db roll_colors_5 >> 8

roll1	ldx #1
	db $2C
roll2	ldx #2
	db $2C
roll3	ldx #3
	db $2C
roll4	ldx #4
	db $2C
roll5	ldx #5
	;
	lda #$20
	sta roll_call
	;
	lda roll_lo,x
	sta roll_call+1
	lda roll_hi,x
	sta roll_call+2
	rts

	align 256
sine
; 128,32
	db $20,$22,$23,$25,$26,$28,$29,$2B,$2C,$2E,$2F,$30,$32,$33,$34,$35
	db $37,$38,$39,$3A,$3B,$3B,$3C,$3D,$3E,$3E,$3F,$3F,$3F,$40,$40,$40
	db $40,$40,$40,$40,$3F,$3F,$3F,$3E,$3E,$3D,$3C,$3B,$3B,$3A,$39,$38
	db $37,$35,$34,$33,$32,$30,$2F,$2E,$2C,$2B,$29,$28,$26,$25,$23,$22
	db $20,$1E,$1D,$1B,$1A,$18,$17,$15,$14,$12,$11,$10,$0E,$0D,$0C,$0B
	db $09,$08,$07,$06,$05,$05,$04,$03,$02,$02,$01,$01,$01,$00,$00,$00
	db $00,$00,$00,$00,$01,$01,$01,$02,$02,$03,$04,$05,$05,$06,$07,$08
	db $09,$0B,$0C,$0D,$0E,$10,$11,$12,$14,$15,$17,$18,$1A,$1B,$1D,$1E
	;
	db $20,$22,$23,$25,$26,$28,$29,$2B,$2C,$2E,$2F,$30,$32,$33,$34,$35
	db $37,$38,$39,$3A,$3B,$3B,$3C,$3D,$3E,$3E,$3F,$3F,$3F,$40,$40,$40
	db $40,$40,$40,$40,$3F,$3F,$3F,$3E,$3E,$3D,$3C,$3B,$3B,$3A,$39,$38
	db $37,$35,$34,$33,$32,$30,$2F,$2E,$2C,$2B,$29,$28,$26,$25,$23,$22
	db $20,$1E,$1D,$1B,$1A,$18,$17,$15,$14,$12,$11,$10,$0E,$0D,$0C,$0B
	db $09,$08,$07,$06,$05,$05,$04,$03,$02,$02,$01,$01,$01,$00,$00,$00
	db $00,$00,$00,$00,$01,$01,$01,$02,$02,$03,$04,$05,$05,$06,$07,$08
	db $09,$0B,$0C,$0D,$0E,$10,$11,$12,$14,$15,$17,$18,$1A,$1B,$1D,$1E

corner_gfx
	db $FF,$F8,$E0,$C0,$C0,$80,$80,$80
	db $FF,$1F,$07,$03,$03,$01,$01,$01
	
and_slices
	db $03,$03,$0C,$0C,$30,$30,$C0,$C0
	
;rainbow
;	db $B,$2,$8,$9,$7,$A,$F,$5
;	db $C,$3,$D,$6,$4
;	db $B,$2,$8,$9,$7,$A,$F,$5
;	db $C,$3,$D,$6,$4
;	db $B,$2,$8,$9,$7,$A,$F,$5
;	db $C,$3,$D,$6,$4

rainbow1
	db $B,$B,$B,$B,$B,$B,$B,$B
	db $2,$2,$8,$8,$9,$9,$7,$7
	db $A,$A,$F,$F,$5,$5,$C,$C
	db $3,$3,$D,$D,$6,$6,$E,$E
	db $4,$4,$4,$4,$4,$4,$4,$4

rainbow2
	db $B,$B,$B,$B,$B,$B,$B,$B
	db $B,$2,$2,$8,$8,$9,$9,$7
	db $8,$A,$A,$F,$F,$5,$5,$C
	db $C,$3,$3,$D,$D,$6,$6,$E
	db $E,$4,$4,$4,$4,$4,$4,$4

final_colors
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10
	db $00,$10,$20,$30,$40,$50,$60
	db $70,$60,$50,$40,$30,$20,$10

text_data
	cmap " ",0
	cmap "A",1,2,3,4,5
	cmap "e", 6
	cmap "F",7,8,9,10
	cmap "i",11
	cmap "J",12,13,14
	cmap "l",15
	cmap "M",16,17,18
	cmap "o",19
	cmap "P",20,21,22
	cmap "r",23
	cmap "S",24,25,26,27,28,29,30,31
	cmap "2",32
	cmap "4",33
	cmap "7",34
	cmap ",",35           
	cmap ".",36
	cmap "!",37
	db "WELCOMe To THIS SMAlL CHRiSTMAS DEMO BY CSABO oF LOD, MADe iN 2O24. "
	db "          "
	db "I HOPE 2O24 WAS AN AWeSOME YeAr FoR YOU, "
	db "AND YOU SPEND THe HOliDAYS HANGING WiTH PEOPLe YOU loVE. "
	db "          "
	db "For THOSe oF YOU THAT LoVE A WHITe CHRiSTMAS, I WiSH YOU lOVELY SNOWFALlS!"
	db "                                      "
	db "HMM, THeSE rASTER COLorS lOoK TILTED... THeY SHOUlD Be HoRiZONTAL. oH WElL!"
	db "                                      "
	db "GrEeTINGS TO "
	db "KiCHY, CHRoNOS, SIZ, lUCA, GErLiCZeR, UNrEAl, TLC, BSZ, RACHY, TCFS, GAIA, "
	db "MUrPHY, EDHelLON, HAPlO, TRP, LBM, GrASS, SHiNe, STARBUCK, "
	db "UlYSSeS777, JEVA, MAD, ePY, "
	db "HAEGAR, MMS, MCG, SUKKoPErA, SPeKTRO, SIrHADiSEN, JiMMYCOUPe, FUZZWEeD, "
	db "AND EVeRYONE ON THE PLUS FOUr SCeNE!"
	db "                       "
	db "MErRY CHrISTMAS 2O24!"
	db "                       "
	db $FF
	cmap

letter_widths
	db 8
	db 10,10,10,10
	db 8,8 ; e/e
	db 10,12
	db 10 ; h
	db 6,4 ; i/i
	db 10,10
	db 10,10 ; l/l
	db 12,12,12,12 ; m,n,o/o
	db 10
	db 12 ; q
	db 10,10 ; r/r
	db 10,10,10
	db 12,12 ; v,w
	db 10,10,10
	;
	db 10,10,10 ; 2,4
	db 6 ; ,
	db 4,4 ; .!

charset_hi
	db charset6 >> 8
	db charset6 >> 8
	db charset4 >> 8
	db charset4 >> 8
	db charset2 >> 8
	db charset2 >> 8
	db charset0 >> 8
	db charset0 >> 8

letter_ptr_lo
	db ($30 * 0) & 255
	db ($30 * 1) & 255
	db ($30 * 2) & 255
	db ($30 * 3) & 255
	db ($30 * 4) & 255
	db ($30 * 5) & 255
	db ($30 * 6) & 255
	db ($30 * 7) & 255
	db ($30 * 8) & 255
	db ($30 * 9) & 255
	db ($30 * 10) & 255
	db ($30 * 11) & 255
	db ($30 * 12) & 255
	db ($30 * 13) & 255
	db ($30 * 14) & 255
	db ($30 * 15) & 255
	db ($30 * 16) & 255
	db ($30 * 17) & 255
	db ($30 * 18) & 255
	db ($30 * 19) & 255
	db ($30 * 20) & 255
	db ($30 * 21) & 255
	db ($30 * 22) & 255
	db ($30 * 23) & 255
	db ($30 * 24) & 255
	db ($30 * 25) & 255
	db ($30 * 26) & 255
	db ($30 * 27) & 255
	db ($30 * 28) & 255
	db ($30 * 29) & 255
	db ($30 * 30) & 255
	db ($30 * 31) & 255
	db ($30 * 32) & 255
	db ($30 * 33) & 255
	db ($30 * 34) & 255
	db ($30 * 35) & 255
	db ($30 * 36) & 255
	db ($30 * 37) & 255

letter_ptr_hi
	db ($30 * 0) >> 8
	db ($30 * 1) >> 8
	db ($30 * 2) >> 8
	db ($30 * 3) >> 8
	db ($30 * 4) >> 8
	db ($30 * 5) >> 8
	db ($30 * 6) >> 8
	db ($30 * 7) >> 8
	db ($30 * 8) >> 8
	db ($30 * 9) >> 8
	db ($30 * 10) >> 8
	db ($30 * 11) >> 8
	db ($30 * 12) >> 8
	db ($30 * 13) >> 8
	db ($30 * 14) >> 8
	db ($30 * 15) >> 8
	db ($30 * 16) >> 8
	db ($30 * 17) >> 8
	db ($30 * 18) >> 8
	db ($30 * 19) >> 8
	db ($30 * 20) >> 8
	db ($30 * 21) >> 8
	db ($30 * 22) >> 8
	db ($30 * 23) >> 8
	db ($30 * 24) >> 8
	db ($30 * 25) >> 8
	db ($30 * 26) >> 8
	db ($30 * 27) >> 8
	db ($30 * 28) >> 8
	db ($30 * 29) >> 8
	db ($30 * 30) >> 8
	db ($30 * 31) >> 8
	db ($30 * 32) >> 8
	db ($30 * 33) >> 8
	db ($30 * 34) >> 8
	db ($30 * 35) >> 8
	db ($30 * 36) >> 8
	db ($30 * 37) >> 8
	
raster_colors_1_orig
	db $71
	db $02,$0B,$12,$1B,$22,$2B,$32,$3B
	db $42,$4B,$52,$5B,$62,$6B,$72,$71
	db $71,$7C,$65,$6C,$55,$5C,$45,$4C
	db $35,$3C,$25,$2C,$15,$1C,$05,$0C
	db 0
raster_colors_2_orig
	db $00
	db $0C,$05,$1C,$15,$2C,$25,$3C,$35
	db $4C,$45,$5C,$55,$6C,$65,$7C,$71
	db $71,$72,$6B,$62,$5B,$52,$4B,$42
	db $3B,$32,$2B,$22,$1B,$12,$0B,$02
	db $00
	
timeline
	dw (reveal_raster_sine_end-reveal_raster_sine), reveal_raster
	dw 9, nothing
	dw 18, fade_in_sides
	dw 9, nothing
	;
	dw 1, fade_in_mid1_00
	dw 1, nothing
	dw 1, fade_in_mid1_01
	dw 1, nothing
	dw 1, fade_in_mid1_01
	dw 1, nothing
	dw 1, fade_in_mid1_01
	dw 1, nothing
	dw 1, fade_in_mid1_01
	dw 1, nothing
	dw 1, fade_in_mid1_01
	dw 1, nothing
	dw 1, fade_in_mid1_01
	dw 1, nothing
	dw 1, fade_in_mid1_01
	dw 1, nothing
	dw 1, fade_in_mid1_02
	dw 9, nothing
	;
	dw 1, fade_in_mid2_00
	dw 1, nothing
	dw 1, fade_in_mid2_01
	dw 1, nothing
	dw 1, fade_in_mid2_01
	dw 1, nothing
	dw 1, fade_in_mid2_01
	dw 1, nothing
	dw 1, fade_in_mid2_01
	dw 1, nothing
	dw 1, fade_in_mid2_01
	dw 1, nothing
	dw 1, fade_in_mid2_01
	dw 1, nothing
	dw 1, fade_in_mid2_01
	dw 1, nothing
	dw 1, fade_in_mid2_02
	;
	dw 40, nothing
	dw 15, reveal_left
	dw 40, nothing
	dw 15, reveal_right
	dw 40, nothing
	dw 1, reveal_bitmap_colors
	dw 1, reveal_bitmap_start
	dw 54, reveal_bitmap
	dw 1, erase_bitmap_line_start
	dw 400, nothing
	dw 23, erase_bitmap_line
	dw 1, nothing
	dw 1, start_scroll
	dw 1, roll5
	dw 105, nothing
	dw 1, set_scroll_color_1
	dw 47, nothing
	dw 1, set_scroll_color_2
	dw 23, nothing
	dw 1, set_scroll_color_3
	dw 156, nothing
	dw 1, roll4
	dw 498, nothing
	dw 1, stop_roll_colors_4
	dw 159, nothing
	;
	dw 1, roll5
	dw 1, set_scroll_color_3
	dw 143, nothing
	dw 1, roll1
	dw 84, nothing
	dw 1, stop_roll_colors_1
	dw 155, nothing
	dw 1, roll3
	dw 200, nothing
	dw 298, switch_color_3
	dw 1, roll2
	dw $FFFF, nothing
	
	include "bitmap_reveal.asm"
	
	include "bitmap.asm"
	
	include "timeline.asm"

	align $0100
	include "charset0.asm"
	align $0100
	include "charset2.asm"
	align $0100
	include "charset4.asm"
	align $0100
	include "charset6.asm"

	align $0800
colormap_64k
	ds $0800
	endif
;eof